#include "defines.mqh"


class Manager;

class Worker : public CObject
{
   Manager             *m_manager;
   objvector<Worker*>   m_colleagues;
   int                  m_id;
public:
                        Worker(Manager *mgr, int id):m_manager(mgr),
                                                     m_id(id){}
   string               symbol() const { return m_manager.symbol(); }
   int                  id()     const { return m_id; }
   objvector<Worker*>*  colleagues();
};

objvector<Worker*>* Worker::colleagues() 
{ 
   objvector<Worker*>* workers = m_manager.workers();
   int mgr_total = workers.Total();
   int col_total = m_colleagues.Total();
   if(mgr_total < 2 || mgr_total -1 == m_colleagues.Total())
      return &m_colleagues;
   m_colleagues.Clear();
   for(int i=0; i<mgr_total; i++) 
      if(workers[i] != &this)
         m_colleagues.Add(workers[i]);
   return &m_colleagues;
}